config/routes.rb
Rails.application.routes.draw do
  resources :deployments, as: 'oasis_switchable_deployments', only: [:show, :create, :destroy]
  resources :switchers, as: 'oasis_switchers'
  root 'switchers#index'
end

app/models/oasis/switcher.rb
module Oasis
  class Switcher
    include ActiveModel::Model
    include ActiveModel::Serializers::JSON

    attr_accessor :id, :port, :object, :name, :labels, :host, :managed_deployment, :managed_deployment_id
    attr_reader :error
  
    def initialize(name:nil, host:nil, port:nil, object:nil)
      @error = nil
      if object
        @object = object
        @persisted = true
        @name = object['metadata']['name']
        @id = @name
        @labels = object['metadata']['labels'].to_h
        @host = object['spec']['host']
        @port = object['spec']['port']['targetPort']
        self.load_managed_deployment
      else
        @id = name
        @name = name
        @host = host
        @port = port
        @labels = {}
        @managed_deployment = nil
        @persisted = false
      end
      params = {
        id: @id,
        name: @name,
        host: @host,
        port: @port,
        managed_deployment_id: @managed_deployment_id
      }
      super(params)
    end

    def attributes
      {'name' => nil, 'host' => nil, 'port' => nil, 'managed_deployment_id' => nil, 'managed_deployment' => nil}
    end

    class << self
      def all = K8sWatcher.instance.list_routes

      def find(id)
        begin
          return K8sWatcher.instance.find_route(id)
        rescue K8s::Error::Forbidden
          raise Oasis::SwitcherError, "action not allowed"
        rescue K8s::Error::NotFound
          raise Oasis::UnknownSwitcherError, "Switcher not found with id #{id}"
        end
      end

      def create(params)
        params = params.to_h.symbolize_keys
        new_switcher = new(
          name: params[:name],
          port: params[:port]
        )
        new_switcher.save
        new_switcher
      end

      def count = K8sWatcher.instance.list_routes.length
    end

    def to_param = @id

    def persisted? = @persisted

    def valid?
      @name && @port && @error.nil?
    end

    def save
      return true if persisted?

      return false unless valid?

      begin
        existing_switcher = Oasis::Switcher.find(name)
        @error = 'switcher already exists with the given name'
        return false
      rescue Oasis::UnknownSwitcherError
        switcher_labels = {
          'oasis.duke.edu/ingress-switcher' => 'true',
          'oasis.duke.edu/ingress-switcher-name' => name
        }
    
        k8s = K8sWatcher.instance
        begin  
          switcher_object = k8s.create_route(
            name: name,
            port: port,
            labels: switcher_labels,
            service: name
          )
        rescue StandardError => e
          @error = e.message
          return false
        end

        switcher_selector = {
          'oasis.duke.edu/ingress-switcher-managed' => 'true',
          "oasis.duke.edu/#{name}-managed" => 'true'
        }
    
        begin
          k8s.create_service(
            name: name,
            port: port,
            labels: switcher_labels,
            selector: switcher_selector
          )
        rescue StandardError => e
          begin
            k8s.delete_route(name: @name)
          rescue StandardError
          end
          @error = e.message
          return false
        end
        @object = switcher_object
        @host = switcher_object['spec']['host']
        @persisted = true
        return true
      end
    end

    def update(params)
      params = params.to_h.symbolize_keys
      raise Oasis::SwitcherError.new('unsupported parameters') unless params.keys == [:managed_deployment_id]

      managed_deployment_id = params[:managed_deployment_id]
      return true if (managed_deployment_id.nil? || managed_deployment_id.blank?) && @managed_deployment_id.nil?

      return true if @managed_deployment && @managed_deployment.id == managed_deployment_id

      if @managed_deployment
        success = self.unset_managed_deployment 
        return success if (managed_deployment_id.nil? || managed_deployment_id.blank?)
      end
      return self.set_managed_deployment(managed_deployment_id)
    end
  
    def destroy
      return true unless persisted?

      begin
        self.unset_managed_deployment
        k8s = K8sWatcher.instance
        k8s.delete_service(name: @name)
        k8s.delete_route(name: @name)
      rescue StandardError => e
        raise Oasis::SwitcherError.new(e.message)
      end
    end

    def managing_label = "oasis.duke.edu/#{@name}-managed"

    def self.managed_deployment_label = 'oasis.duke.edu/ingress-switcher-managed'

    # these are publicly available for testing, but should not be used outside of testing
    def unset_managed_deployment
      return true unless @managed_deployment

      if @managed_deployment.update({labels: { self.managing_label => nil }})
        @managed_deployment_id = nil
        @managed_deployment = nil
        return true
      end
      return false
    end

    def set_managed_deployment(new_managed_deployment_id)
      @managed_deployment = Oasis::SwitchableDeployment.find(new_managed_deployment_id)
      if @managed_deployment.update({labels: { managing_label => 'true' }})
        @managed_deployment_id = managed_deployment_id
        return true
      else
        @error = @managed_deployment.error
        return false
      end
    end

    private

    def load_managed_deployment
      @managed_deployment = K8sWatcher.instance.get_deployment_managed_by(@id)
      if @managed_deployment
        @managed_deployment_id = @managed_deployment.id
      end
    end
  end
end

app/controllers/switchers_controller.rb
class SwitchersController < ApplicationController
  before_action :set_switcher, only: %i[show update destroy]

  def index
    @switchers = Oasis::Switcher.all
    get_deployments    
  end

  # get /switchers/name
  def show;end

  # PATCH/PUT /switchers/name
  def update
    manage_unmanaged_deployment_list
    respond_to do |format|
      if @switcher.update(update_switcher_params)
        format.turbo_stream
        format.html { redirect_to oasis_switcher_url(@switcher), notice: 'switcher was successfully updated.' }
      else
        format.turbo_stream { render @switcher, status: :unprocessable_entity }
        format.html { render @switcher, status: :unprocessable_entity }
      end
    end
  end

  # POST /switchers
  def create
    @switcher = Oasis::Switcher.new(**create_switcher_params.to_h.symbolize_keys)
    respond_to do |format|
      if @switcher.save
        format.turbo_stream
        format.html { redirect_to oasis_switcher_url(@switcher), notice: 'Switcher was successfully created.' }
      else
        format.turbo_stream { render :show, status: :unprocessable_entity }
        format.html { render :show, status: :unprocessable_entity }
      end
    end
  end

  def destroy
    respond_to do |format|
      @switcher.destroy
      format.turbo_stream
      format.html { redirect_to oasis_switchers_url }
    end
  end

  private

  def get_deployments
    @deployment_names = []
    @unmanaged_deployments = Oasis::SwitchableDeployment.all.reject do |m|
      @deployment_names << m.name
      @switchers.any? do |switcher|
        switcher.managed_deployment_id == m.id
      end
    end
  end

  def set_switcher
    @switcher = Oasis::Switcher.find(params[:id])
  end

  def manage_unmanaged_deployment_list
    @remove_unmanaged_deployment_id = update_switcher_params.to_h.symbolize_keys[:managed_deployment_id]
    @add_unmanaged_deployment = @switcher.managed_deployment if @switcher.managed_deployment_id != @remove_unmanaged_deployment_id
  end

  def update_switcher_params = params.require(:oasis_switcher).permit(%i[managed_deployment_id])
  def create_switcher_params = params.require(:oasis_switcher).permit(%i[name port])
end

app/helpers/switchers_helper.rb
module SwitchersHelper
end

app/views/switchers/_form.html.erb
<%= turbo_frame_tag "new-switcher-form" do %>
  <%= form_with(model: Oasis::Switcher.new) do |form| %>
    <div class="field">
      <%= form.label :name %>
      <%= form.text_field :name %>
    </div>

    <div class="field">
      <%= form.label :port %>
      <%= form.text_field :port %>
    </div>

    <div>
      <%= form.submit "Create" %>
    </div>
  <% end -%>
<% end -%>

app/views/switchers/_switcher.html.erb
<%= turbo_frame_tag "#{switcher.id}-frame" do %>
<p><a href="https://<%= switcher.host %>"><%= switcher.name %></a></p>
<% if switcher.persisted? -%>
<%= link_to 'Destroy', oasis_switcher_path(switcher),
            data: {turbo_method: :delete, turbo_confirm: 'Are you sure?'} %>
<% end -%>
<%= form_with(
  id: switcher.id, 
  model: switcher, 
  data: {
    "blockly-target" => 'switcherForm',
    "switcher" => "#{switcher.to_json}"
  }) do |form| %>
  <div class="field">
    <%= form.label :managed_deployment %>
    <%= form.text_field :managed_deployment_id, id: "#{switcher.name}_managed_deployment_id" %>
  </div>

  <div>
    <%= form.submit "Update" %>
  </div>
<% end -%>
<% end -%>

app/views/switchers/create.turbo_stream.erb
<% unless @switcher.error -%>
    <%= turbo_stream.append "switchers" do %>
      <li id="<%= @switcher.id %>-item">
        <%= render 'switchers/switcher', switcher: @switcher %>
      </li>
    <% end -%>
<% end -%>
<%= turbo_stream.replace "new-switcher-form" do -%>
  <%= render partial: "switchers/form" %>
<% end -%>

app/views/switchers/destroy.turbo_stream.erb
<%= turbo_stream.remove "#{@switcher.id}-item" %>

app/views/switchers/index.html.erb
<div id="blockly_container" data-controller="blockly">
  <div class="container">
    <div class="row">
      <div class="col-6">
        <%= content_tag(:div, "", id: "blockly", style: "width:auto; height: 480px", data: {
                blockly_target: "container"
            }) %>
      </div>
    </div>
  </div>
<h2>Switchers</h2>
<%= render partial: "switchers/form" %>
<ul id="switchers">
<% @switchers.each do |switcher| -%>
  <li id="<%= switcher.id %>-item">
    <%= render 'switchers/switcher', switcher: switcher %>
  </li>
<% end -%>
</ul>
<h2>Unmanaged Deployments</h2>
<%= render partial: "deployments/form" %>
<div id="deployment_creation_error"></div>
<ul id="unmanaged_deployments">
<% @unmanaged_deployments.each do |md| -%>
  <li id="<%= md.id %>-item">
    <%= render 'deployments/deployment', deployment: md %>
  </li>
<% end -%>
</ul>

app/views/switchers/show.html.erb
<%= render 'switchers/switcher', switcher: @switcher %>

app/views/switchers/update.turbo_stream.erb
<%= turbo_stream.replace "switchers" do %>
  <li id="<%= @switcher.id %>-item">
    <%= render 'switchers/switcher', switcher: @switcher %>
  </li>
<% end -%>
<% if @add_unmanaged_deployment -%>
  <%= turbo_stream.append "unmanaged_deployments" do %>
    <li id="<%=@add_unmanaged_deployment.id %>-item">
      <%= render 'deployments/deployment', deployment: @add_unmanaged_deployment %>
    </li>
  <% end -%>
<% end -%>
<% if @remove_unmanaged_deployment_id -%>
  <%= turbo_stream.remove "#{@remove_unmanaged_deployment_id}-item" %>
<% end -%>